
local addonName, addonData = ...

local showToonName = true
local showRealmName = showToonName and true
local debugMessages = true

local function ColorBNetWhispers(self,event,message,sender,...)
	local args = { ... }

	--("message", "sender", "unknown", "unknown", "unknown", "unknown", unknown, unknown, "unknown", unknown, counter, "unknown", presenceID, unknown)

	local presenceID = args[11]

	local toonInfo = { BNGetToonInfo(presenceID) }
	--unknown, toonName, client, realmName, realmID, faction, race, class, unknown, zoneName, level, gameText, broadcastText, broadcastTime, unknown, presenceID

	if debugMessages then 
		print("Receiving Battle Net Message ", message, " from ", sender, " who is playing ", toonInfo[3]) 
	end
	
	if toonInfo[3] ~= "WoW" then 
		return message,sender,... 
	end

	local toonName = toonInfo[2]
	local realmName = toonInfo[4]
	local class = toonInfo[8]

	if debugMessages then 
		print("They are playing their toon ",toonName, " which is class ", class,"/",addonData.ClassNames[class], " on Realm ",realmName) 
	end

	local color = RAID_CLASS_COLORS[class]
	if not color then 
		color = RAID_CLASS_COLORS[addonData.ClassNames[class]] 
	end
	local colorHex = color.colorStr

	if showToonName then
		if showRealmName then
			coloredSender = string.format("|c%s%s (%s-%s)|r",colorHex,sender,toonName,realmName)
		else
			coloredSender = string.format("|c%s%s (%s)|r",colorHex,sender,toonName)
		end
	else
		coloredSender = string.format("|c%s%s|r",colorHex,sender)
	end

	if debugMessages then 
		print("Sender Name should now show as : ", coloredSender)
	end

	return message,coloredSender,...
end

addonData.XRICEvents = CreateFrame("Frame")
addonData.XRICEvents:RegisterEvent("PLAYER_LOGIN")
addonData.XRICEvents:SetScript("OnEvent",function(self,event,...)

	addonData.ClassNames = {}
	for k, v in pairs(LOCALIZED_CLASS_NAMES_MALE) do
	        addonData.ClassNames[v] = k
	end
	for k, v in pairs(LOCALIZED_CLASS_NAMES_FEMALE) do
	        addonData.ClassNames[v] = k
	end

	ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_WHISPER", ColorBNetWhispers)

end)
